;;; DvorakJ
;;; 1.0.48 Script <http://www.autohotkey.com/>
;;; Last Modified: 2009-03-07
;;; blechmusik (blechmusik@gmail.com) <http://blechmusik.xrea.jp/>

;;; ============================================================================
;;; ---------------- CZXXV𓙂ɂĂ README.txt B
;;; ============================================================================

;;; ============================================================================
;;; ---------------- eݒ
;;; ============================================================================

SendMode Input
#NoEnv
#SingleInstance FORCE
#WinActivateForce
#UseHook


;;; ============================================================================
;;; ---------------- IME.ahk.inc ̓ǂݍ
;;; ============================================================================

;;; IME.ahk  AutoHotokey𗬍s点Abv[_ <http://lukewarm.s101.xrea.com/up/>  089.zip [Shift&Space + IME.ahk] (2008/09/21 20:18) Ɋ܂܂Ă܂B
;;; IME.ahk  NYSL <http://www.kmonos.net/nysl/> ŌJĂ܂B
;;; IME.ahk ɂẮAL zip t@CɎ^Ă IME.txt B

#Include ./inc/IME.ahk.inc

;;; ============================================================================
;;; ---------------- ini t@CŊǗ鍀
;;; ============================================================================

#Include ./inc/ini.ahk.inc

;;; ============================================================================
;;; ---------------- QWERTY z񂩂 Dvorokzւ̕ϊ\
;;; ============================================================================

#Include ./inc/QWERTY.ahk.inc

;;; ============================================================================
;;; ---------------- EBhE̐ݒ
;;; ============================================================================

#Include ./inc/window.ahk.inc

;;; ============================================================================
;;; ---------------- Dvorak z QWERTY z̐؂ւ̐ݒ
;;; ============================================================================

#Include ./inc/toggle_layout.ahk.inc

;;; ============================================================================
;;; ---------------- IME ̗LƖ̐؂ւ̐ݒ
;;; ============================================================================

#Include ./inc/toggle_IME.ahk.inc

;;; ============================================================================
;;; ---------------- q̃`FbN𒆎~
;;; ============================================================================

ResetKeyChecking() {
	global Is_PriorHotkey_consonant := 0
	global Is_Youon_h := 0
	global Is_Youon_n := 0

	global Is_PriorHotkey_consonant := 0
	global Is_Priorkey_syouryaku := 0
	global Is_Priorkey_youon := 0
	global Is_Priorkey_sn := 0
}

;;; ============================================================================
;;; ---------------- g͕̎gp̗L@Shift 
;;; ============================================================================

SendDvorak_ExtendedIMShift()
{
	ResetKeyChecking()

	global Extended_IM_On_Off
	global Extended_IM_Which
	global Dvorak_Layout
	global W_E_keys_assignment


	if Extended_IM_On_Off = 0
	{
		mode := 0
	}
	else
	if Extended_IM_On_Off = 1
	{
		mode := IME_GET()
	}
	else
	if Extended_IM_On_Off = 2
	{
		mode := 1
	}


	IfInString, A_ThisHotkey, +
		StringTrimLeft, this_key, A_ThisHotkey, 1
	IfInString, A_ThisHotkey, &
		StringTrimLeft, this_key, A_ThisHotkey, 8

	StringTrimRight, Dvorak_key, qwerty_shift_%this_key%, 0


	if A_PriorHotkey contains ~,*,^,#
		Prior_Dvorak_key := 0
	else
	if A_PriorHotkey contains +,&
	{
		if A_PriorHotkey contains +
			StringTrimLeft, Prior_Dvorak_key, A_PriorHotkey, 1
		else
		if A_PriorHotkey contains &
			StringTrimLeft, Prior_Dvorak_key, A_PriorHotkey, 8


		StringTrimRight, Prior_Dvorak_key, qwerty_shift_%Prior_Dvorak_key%, 0
	}
	else
		StringTrimRight, Prior_Dvorak_key, qwerty_%A_PriorHotkey%, 0


	if this_key = 9
	{
		if Dvorak_Layout = 1
			Dvorak_key := 4
		else
		{
			if W_E_keys_assignment = 1
				Dvorak_key := "<"
			else
				Dvorak_key := "("
		}
	}
	else
	if this_key = 0
	{
		if Dvorak_Layout = 1
			Dvorak_key := 6
		else
		{
			if W_E_keys_assignment = 1
				Dvorak_key := ">"
			else
				Dvorak_key := ")"
		}
	}
	else
	if this_key = sc00C
	{
		if Dvorak_Layout = 1
			Dvorak_key := 8
		else
		{
			if W_E_keys_assignment = 2
				Dvorak_key := "<"
			else
				Dvorak_key := "{{}"
		}
	}
	else
	if this_key = sc00D
	{
		if Dvorak_Layout = 1
			Dvorak_key := "``"
		else
		{
			if W_E_keys_assignment = 2
				Dvorak_key := ">"
			else
				Dvorak_key := "{}}"
		}
	}
	else
	if this_key = sc07D
	{
		Dvorak_key = +%Dvorak_key%
	}
	else
	if (mode = 1 and Extended_IM_Which = 4)
	{
		SendSouseiShift(Dvorak_key,Prior_Dvorak_key)

		return
	}
	else
	if this_key = q
	{
		if Dvorak_Layout = 1
			Dvorak_key := ":"
		else
			Dvorak_key = "
	}
	else
	if this_key = w
	{
		if (W_E_keys_assignment = 0 or Dvorak_Layout = 1)
			Dvorak_key := "<"
		else
		if W_E_keys_assignment = 1
			Dvorak_key := "("
		else
		if W_E_keys_assignment = 2
			Dvorak_key := "{{}"
	}
	else
	if this_key = e
	{
		if (W_E_keys_assignment = 0 or Dvorak_Layout = 1)
			Dvorak_key := ">"
		else
		if W_E_keys_assignment = 1
			Dvorak_key := ")"
		else
		if W_E_keys_assignment = 2
			Dvorak_key := "{}}"
	}
	else
	if this_key = z
	{
		if Dvorak_Layout = 1
			Dvorak_key = "
		else
			Dvorak_key := ":"
	}


	Send,%Dvorak_key%

	return
}

;;; ============================================================================
;;; ---------------- g͕̎gp̗L@Shift 
;;; ============================================================================

SendDvorak_ExtendedIM()
{
	global Is_PriorHotkey_consonant
	global Is_Youon_h
	global Is_Youon_n
	global Extended_IM_Which
	global Extended_IM_On_Off

	if Extended_IM_On_Off = 0
	{
		mode := 0

		ResetKeyChecking()
	}
	else
	if Extended_IM_On_Off = 1
	{
		mode := IME_GET()
	}
	else
	if Extended_IM_On_Off = 2
	{
		mode := 1
	}



	StringTrimRight, Dvorak_key, qwerty_%A_ThisHotkey%, 0



	if A_PriorHotkey contains ~,*,^,#
		Prior_Dvorak_key := 0
	else
	if A_PriorHotkey contains +,&
	{
		if A_PriorHotkey contains +
			StringTrimLeft, Prior_Dvorak_key, A_PriorHotkey, 1
		else
		if A_PriorHotkey contains &
			StringTrimLeft, Prior_Dvorak_key, A_PriorHotkey, 8


		StringTrimRight, Prior_Dvorak_key, qwerty_shift_%Prior_Dvorak_key%, 0
	}
	else
		StringTrimRight, Prior_Dvorak_key, qwerty_%A_PriorHotkey%, 0



	if mode = 1
	{
		if Extended_IM_Which = 1
		{
			if Dvorak_key in a,o,e,u,i
			{
				SendDvorakJP_Vowel(Dvorak_key,Prior_Dvorak_key)
			}
			else ; diphthong and hatuon
			if Dvorak_key in ,,,`',.,`;,q,j,k,x
			{
				SendDvorakJP_Diphthong_and_Hatuon(Dvorak_key,Prior_Dvorak_key)
			}
			else
			if Dvorak_key in p,y,f,g,c,r,l,d,h,t,n,s,b,m,w,v,z
			{
				SendDvorakJP_Consonant(Dvorak_key,Prior_Dvorak_key)
			}
			else
			if Dvorak_key in -,/,$,``
			{
				Send,{%Dvorak_key%}
			}
		}
		else
		if Extended_IM_Which = 2
		{
			SendDvorakY(Dvorak_key)
		}
		else
		if Extended_IM_Which = 3
		{
			if Dvorak_key in ,,,`',.,p,y,a,o,e,u,i,`;,q,j,k
			{
				SendACT_Vowel(Dvorak_key,Prior_Dvorak_key)
			}
			else
			if Dvorak_key in f,g,c,r,l,d,h,t,n,s,b,m,w,v,z
			{
				SendACT_Consonant(Dvorak_key,Prior_Dvorak_key)
			}
			else
			if Dvorak_key in -,/,$,``
			{
				Send,{%Dvorak_key%}
			}
		}
		else
		if Extended_IM_Which = 4
		{
			SendSousei_Normal(Dvorak_key,Prior_Dvorak_key)
		}
		else
		if Extended_IM_Which = 5
		{
			if Dvorak_key in ,,,`',.,p,y,a,o,e,u,i,`;,q,j,k,x
			{
				SendJLOD_Vowel(Dvorak_key,Prior_Dvorak_key)
			}
			else
			if Dvorak_key in f,g,c,r,l,d,h,t,n,s,b,m,w,v,z
			{
				SendJLOD_Consonant(Dvorak_key,Prior_Dvorak_key)
			}
			else
			if Dvorak_key in -,/,$,``
			{
				Send,{%Dvorak_key%}
			}
		}
		else
		{
			Send,%Dvorak_key%
		}
	}
	else
	{
		Send,%Dvorak_key%

	}


	return
}

;;; ============================================================================
;;; ---------------- DvorakJP ̐ݒ
;;; ============================================================================

#Include ./inc/layout/DvorakJP.ahk.inc

;;; ============================================================================
;;; ---------------- DvorakY ̐ݒ
;;; ============================================================================

#Include ./inc/layout/DvorakY.ahk.inc

;;; ============================================================================
;;; ---------------- ACT ̐ݒ
;;; ============================================================================

#Include ./inc/layout/ACT.ahk.inc

;;; ============================================================================
;;; ---------------- ̐ݒ
;;; ============================================================================

#Include ./inc/layout/Sousei.ahk.inc

;;; ============================================================================
;;; ---------------- JLOD ̐ݒ
;;; ============================================================================

#Include ./inc/layout/JLOD.ahk.inc

;;; ============================================================================
;;; ---------------- h j k l ̃L[ŃJ[\ړ
;;; ============================================================================

#Include ./inc/hjkl.ahk.inc

;;; ============================================================================
;;; ---------------- ESC ̃L[̊g
;;; ============================================================================

#Include ./inc/ESC.ahk.inc

;;; ============================================================================
;;; ---------------- ēǂݍ݂̐ݒ
;;; ============================================================================

#Include ./inc/reloading.ahk.inc

;;; ============================================================================
;;; ---------------- Ctrl + M  Enter Ƃ
;;; ============================================================================

^m::
	ResetKeyChecking()

	if Ctrl_M_to_Enter = 1
	{
		Send,{Enter}
	}
	else
	{
		Send,{%A_ThisHotkey%}
	}

	return


;;; ============================================================================
;;; ---------------- REMAP TO DVORAK
;;; ============================================================================

;;; ============================================================================
;;; ---------------- Xy[XEL[VtgL[̂ƂĎgp邽߂̏
;;; ============================================================================

+space::
	ResetKeyChecking()
	Send,+{space}
	return

space::
	ResetKeyChecking()
	Send,{space}
	return

;;; ============================================================================
;;; ---------------- łɃVtgEL[Ƃ̑gݍ킹`̂QƂ
;;; ============================================================================

Space & 1::
Space & 2::
Space & 3::
Space & 4::
Space & 5::
Space & 6::
Space & 7::
Space & 8::
Space & 9::
Space & 0::
Space & sc00C::
Space & sc00D::
Space & sc07D::
Space & w::
Space & e::
Space & r::
Space & t::
Space & y::
Space & u::
Space & i::
Space & o::
Space & p::
Space & @::
Space & [::
Space & a::
Space & s::
Space & d::
Space & f::
Space & g::
Space & h::
Space & j::
Space & k::
Space & l::
Space & sc027::
Space & sc02B::
Space & x::
Space & c::
Space & v::
Space & b::
Space & n::
Space & m::
Space & q::
Space & sc028::
Space & z::
Space & sc033::
Space & sc034::
Space & sc035::
Space & sc073::
	if SandS = 1
	{
		SendDvorak_ExtendedIMShift()
	}
	else
	{
		Send,{%A_ThisHotkey%}
	}
	
	return


;;; ============================================================================
;;; ---------------- VtgL[ĂƂ̐ݒ
;;; ============================================================================
;;; ============================================================================
;;; ---------------- łɃVtgEL[Ƃ̑gݍ킹`̂QƂ
;;; ============================================================================

+1::
+2::
+3::
+4::
+5::
+6::
+7::
+8::
+9::
+0::
+sc00C::
+sc00D::
+sc07D::
+w::
+e::
+r::
+t::
+y::
+u::
+i::
+o::
+p::
+@::
+[::
+a::
+s::
+d::
+f::
+g::
+h::
+j::
+k::
+l::
+sc027::
+sc02B::
+x::
+c::
+v::
+b::
+n::
+m::
+q::
+sc028::
+z::
+sc033::
+sc034::
+sc035::
+sc073::
	SendDvorak_ExtendedIMShift()
	return


;;; ============================================================================
;;; ---------------- RʁAۊʁAp
;;; ============================================================================




;;; ============================================================================
;;; ---------------- L[PƂœ͂Ƃ
;;; ============================================================================

1::
2::
3::
4::
5::
6::
7::
8::
9::
0::
sc00C::
sc00D::
[::
	ResetKeyChecking()


	StringTrimRight, Dvorak_key, qwerty_%A_ThisHotkey%, 0
	Send,%Dvorak_key%
	return




q::
w::
e::
r::
t::
y::
u::
i::
o::
p::
@::
a::
s::
d::
f::
g::
h::
j::
k::
l::
sc027::
sc028::
sc02B::
z::
x::
c::
v::
b::
n::
m::
sc033::
sc034::
sc035::
	SendDvorak_ExtendedIM()
	return


;;; ============================================================================
;;; ---------------- Ԃ̕ێ𒆎~
;;; ============================================================================



~*Up::
~*Down::
~*Left::
~*Right::
~*Ins::
~*Home::
~*End::
~*PgUp::
~*PgDn::
~*BS::
~*Delete::
~*Tab::
~*Enter::
~*NumpadDiv::
~*NumpadMult::
~*NumpadAdd::
~*NumpadSub::
~*NumpadEnter::
~*NumpadDel::
~*NumpadIns::
~*NumpadClear::
~*NumpadUp::
~*NumpadDown::
~*NumpadLeft::
~*NumpadRight::
~*NumpadHome::
~*NumpadEnd::
~*NumpadPgUp::
~*NumpadPgDn::
~*Numpad0::
~*Numpad1::
~*Numpad2::
~*Numpad3::
~*Numpad4::
~*Numpad5::
~*Numpad6::
~*Numpad7::
~*Numpad8::
~*Numpad9::
~*NumpadDot::
~*F1::
~*F2::
~*F3::
~*F4::
~*F5::
~*F6::
~*F7::
~*F8::
~*F9::
~*F10::
~*F11::
~*F12::
	ResetKeyChecking()
	Return


;;; ============================================================================
;;; ---------------- L̐ݒȊO
;;; ============================================================================


*sc00C:: ; -
*sc00D:: ; ^
*sc07D:: ; \
*q::
*w::
*e::
*r::
*t::
*y::
*u::
*i::
*o::
*p::
*@::
*[::
*a::
*s::
*d::
*f::
*g::
*h::
*j::
*k::
*l::
*sc027:: ; ;
*sc028:: ; :
*]::
*z::
*x::
*c::
*v::
*b::
*n::
*m::
*sc033:: ; ,
*sc034:: ; .
*sc035:: ; /
*sc070:: ; Ђ炪
*sc073:: ; \
	ResetKeyChecking()

	StringTrimLeft, this_key, A_ThisHotkey, 1


	Modifiers =
	GetKeyState, state1, LWin
	GetKeyState, state2, RWin
	state = %state1%%state2%

	if state <> UU  ; At least one Windows key is down.
		Modifiers = %Modifiers%#

	GetKeyState, state1, Alt
	if state1 = D
		Modifiers = %Modifiers%!

	GetKeyState, state1, Shift
	if state1 = D
	{
		Modifiers = %Modifiers%+
		StringTrimRight, Dvorak_key, qwerty_shift_%this_key%, 0
	}
	else
	{
		StringTrimRight, Dvorak_key, qwerty_%this_key%, 0
	}

	GetKeyState, state1, Control
	if state1 = D
	{
		Modifiers = %Modifiers%^

		if CTRL_Dvorak = 0
			Dvorak_key = %this_key%
	}

	Send %Modifiers%{%Dvorak_key%}

	return



#UseHook off