;;; ============================================================================
;;; ---------------- DvorakJP: ꉹ
;;; ============================================================================

SendDvorakJP_Vowel(ByRef this_key, ByRef prior_key)
{
	global Is_C

	if Is_C = 1
		Send,k%this_key%
	else
		Send,%this_key%

	ResetKeyChecking()
	return
}


;;; ============================================================================
;;; ---------------- DvorakJP: Diphthong & Hatuon
;;; ============================================================================

SendDvorakJP_Diphthong_and_Hatuon(ByRef this_key, ByRef prior_key)
{
	global Is_PriorHotkey_consonant
	global Is_Youon_h
	global Is_Youon_n
	global Is_C

	if Is_PriorHotkey_consonant = 1
	{
		if InStr(A_ThisHotkey, "sc010") ; '
			this_key := "ai"
		else
		if this_key = ,
			this_key := "ou"
		else
		if this_key = .
			this_key := "ei"
		else
		if InStr(A_ThisHotkey, "sc02C") ; ;
			this_key := "ann"
		else
		if this_key = q
			this_key := "onn"
		else
		if this_key = j
			this_key := "enn"
		else
		if this_key = k
			this_key := "unn"
		else
		if this_key = x
			this_key := "inn"


		if Is_C = 1
		{
			Send,k%this_key%
			Is_C =
		}
		else
			Send,%this_key%

		ResetKeyChecking()
	}
	else
	{
		Is_Youon_n =
		Is_Youon_h =

		;; q
		if this_key in q,j,k,x
		{
			Is_PriorHotkey_consonant := 1
		}

		;; h O[v
		if this_key in q,j,x
		{
			Is_Youon_h := 1
		}


		if Is_C = 1
		{
			Send,k%this_key%
			Is_C =
		}
		else
			Send,%this_key%
	}


	return
}



;;; ============================================================================
;;; ---------------- DvorakJP: Consonant
;;; ============================================================================


SendDvorakJP_Consonant(ByRef this_key, ByRef prior_key)
{
	global Is_PriorHotkey_consonant
	global Is_Youon_h
	global Is_Youon_n
	global Is_C

	Is_PriorHotkey_consonant := 1


	if this_key = c
	{
		if Is_C = 1
		{
			this_key = k
		}
		else
		{
			Is_C := 1
			this_key = 
		}

		Is_Youon_h =
		Is_Youon_n := 1
	}
	else
	if this_key = h
	{
		if Is_Youon_h = 1 ; Xg h gpO[v
		{
			this_key = y

			if Is_C = 1
			{
				this_key = k%this_key%
			}

			Is_Youon_h =
			Is_Youon_n =
		}
		else
		{
			if Is_C = 1
			{
				this_key = c%this_key%
			}

			Is_Youon_h =
			Is_Youon_n := 1
		}

		Is_C =
	}
	else
	if this_key = n
	{
		if Is_Youon_n = 1
		{
			this_key = y

			if Is_C = 1
			{
				this_key = k%this_key%
			}

			Is_Youon_h =
			Is_Youon_n =
		}
		else
		{
			Is_Youon_h := 1

			if prior_key = n
			{
				ResetKeyChecking()
			}
		}

		Is_C =
	}
	else
	;; h O[v
	if this_key in p,r,l,s,w,v,z
	{
		Is_Youon_h := 1
		Is_Youon_n =

		if Is_C = 1
		{
			this_key = k%this_key%
		}

		Is_C =
	}
	else ; n O[v
	if this_key in f,g,c,d,t,b,m
	{
		Is_Youon_h =
		Is_Youon_n := 1

		if Is_C = 1
		{
			this_key = k%this_key%
		}

		Is_C =
	}


	Send,%this_key%


	return
}
