;;; ============================================================================
;;; ---------------- DvorakJP: ꉹ
;;; ============================================================================

SendDvorakJP_Vowel(Dvorak_key,Prior_Dvorak_key)
{
	global Is_C

	if Is_C = 1
		Send,k%Dvorak_key%
	else
		Send,%Dvorak_key%

	ResetKeyChecking()
	return
}


;;; ============================================================================
;;; ---------------- DvorakJP: Diphthong & Hatuon
;;; ============================================================================

SendDvorakJP_Diphthong_and_Hatuon(Dvorak_key,Prior_Dvorak_key)
{
	global Is_PriorHotkey_consonant
	global Is_Youon_h
	global Is_Youon_n
	global Dvorak_Layout
	global Is_C

	if Is_PriorHotkey_consonant = 1
	{
		if Dvorak_Layout = 1
		{
			;;; dꉹg
			if Dvorak_key = `;
				Dvorak_key := "ai"
			else
			if Dvorak_key = '
				Dvorak_key := "ann"
		}
		else
		{
			;;; dꉹg
			if Dvorak_key = '
				Dvorak_key := "ai"
			else
			if Dvorak_key = `;
				Dvorak_key := "ann"
		}

		if Dvorak_key = ,
			Dvorak_key := "ou"
		else
		if Dvorak_key = .
			Dvorak_key := "ei"
		else
		if Dvorak_key = q
			Dvorak_key := "onn"
		else
		if Dvorak_key = j
			Dvorak_key := "enn"
		else
		if Dvorak_key = k
			Dvorak_key := "unn"
		else
		if Dvorak_key = x
			Dvorak_key := "inn"


		if Is_C = 1
		{
			Send,k%Dvorak_key%
			Is_C =
		}
		else
			Send,%Dvorak_key%

		ResetKeyChecking()
	}
	else
	{
		Is_Youon_n =
		Is_Youon_h =

		;; q
		if Dvorak_key in q,j,k,x
		{
			Is_PriorHotkey_consonant := 1
		}

		;; h O[v
		if Dvorak_key in q,j,x
		{
			Is_Youon_h := 1
		}


		if Is_C = 1
		{
			Send,k%Dvorak_key%
			Is_C =
		}
		else
			Send,%Dvorak_key%
	}


	return
}



;;; ============================================================================
;;; ---------------- DvorakJP: Consonant
;;; ============================================================================


SendDvorakJP_Consonant(Dvorak_key,Prior_Dvorak_key)
{
	global Is_PriorHotkey_consonant
	global Is_Youon_h
	global Is_Youon_n
	global Is_C

	Is_PriorHotkey_consonant := 1


	if Dvorak_key = c
	{
		if Is_C = 1
		{
			Dvorak_key = k
		}
		else
		{
			Is_C := 1
			Dvorak_key = 
		}

		Is_Youon_h =
		Is_Youon_n := 1
	}
	else
	if Dvorak_key = h
	{
		if Is_Youon_h = 1 ; Xg h gpO[v
		{
			Dvorak_key = y

			if Is_C = 1
			{
				Dvorak_key = k%Dvorak_key%
			}

			Is_Youon_h =
			Is_Youon_n =
		}
		else
		{
			if Is_C = 1
			{
				Dvorak_key = c%Dvorak_key%
			}

			Is_Youon_h =
			Is_Youon_n := 1
		}

		Is_C =
	}
	else
	if Dvorak_key = n
	{
		if Is_Youon_n = 1
		{
			Dvorak_key = y

			if Is_C = 1
			{
				Dvorak_key = k%Dvorak_key%
			}

			Is_Youon_h =
			Is_Youon_n =
		}
		else
		{
			Is_Youon_h := 1

			if Prior_Dvorak_key = n
			{
				ResetKeyChecking()
			}
		}

		Is_C =
	}
	else
	;; h O[v
	if Dvorak_key in p,r,l,s,w,v,z
	{
		Is_Youon_h := 1
		Is_Youon_n =

		if Is_C = 1
		{
			Dvorak_key = k%Dvorak_key%
		}

		Is_C =
	}
	else ; n O[v
	if Dvorak_key in f,g,c,d,t,b,m
	{
		Is_Youon_h =
		Is_Youon_n := 1

		if Is_C = 1
		{
			Dvorak_key = k%Dvorak_key%
		}

		Is_C =
	}


	Send,%Dvorak_key%


	return
}
