If Special_extension = 1
{
	special_extension_file = special_extension.txt

	FileRead, special_extension_all, % special_extension_file

	special_extension_all := RegExReplace(special_extension_all, "#.*?`r`n", "")
	special_extension_all := RegExReplace(special_extension_all, "s)/\*.*?\*/", "")
}

SendSpecial_Key(Dvorak_key,Prior_Dvorak_key){
	global special_extension_all
	global special_extension_first
	global Is_C

	if special_extension_first = 1
	{
		Loop, parse, special_extension_all, `r`n
		{
			special_extension_stroke = %Prior_Dvorak_key%%Dvorak_key%
			special_extension_stroke := RegExReplace(special_extension_stroke, "," , ",,")

			if A_LoopField contains %special_extension_stroke%=
			{
				ResetKeyChecking()

				equal_pos := InStr(A_LoopField,"=")
				StringTrimLeft, OutputVar, A_LoopField, equal_pos

				if Is_C not in 1
				{
					OutputVar = {BS}%OutputVar%
				}

				Send,%OutputVar%
				exit
			}
		}
	}

	special_extension_first := 1
	return
}

